<?php
/**
 * Viper2 Framework
 *
 * @author fish <fish@archa.cz>
 * @package Viper2
 * @version 0.1
 *
 */
/**
 * plugin pro prihlasovani
 *
 * @package Login
 * @author fish <fish@archa.cz>
 * @version 0.1
 *
 */

require_once LIBS_DIR . '/composer/archa/fred/flogin.php';
require_once LIBS_DIR . '/composer/archa/fred/flogin_user.php';

class Login extends Viper2Plugin {
  /**
   * variable $cfgSysId
   * @static integer ID login systemu
   */
  protected $cfgSysId = NULL;
  /**
   * variable $cfgLoginTime
   * @static integer zivotnost prihlaseni (v sekundach)
   */
  protected $cfgLoginTime = NULL;

  /**
   * variable $flogin
   * @protected object login system
   */
  protected $flogin = NULL;
  /**
   * variable $cfgUseSha1
   * @var boolean boolean heslo je ulozene jako SHA1
   */
  protected $cfgUseSha1 = FALSE;
  /**
   * variable $cfgDisableIPCheck
   * @var boolean nekontrolovat IP uzivatele
   */
  public $cfgDisableIPCheck = FALSE;

  function __construct() {
    $this->pluginName = "Login";
    // $this->pluginUri = "/--login/";
    $this->setPriority(-500000);
  }
  
  public function actionGlobal() {
    if(!isset($this->cfgSysId)){
      throw new Exception(get_class($this)." system ID not set");
    }

    Viper2::setVar("logged", FALSE);
    Viper2::setVar("loginUid", 0);
    
    $this->flogin = new flogin($this->dbh, $this->cfgSysId);
    
    $this->flogin->useSha1 = $this->cfgUseSha1;
    $this->flogin->disableIPCheck = $this->cfgDisableIPCheck;
    
    if (!empty($this->cfgLoginTime)) {
      $this->flogin->login_time = $this->cfgLoginTime;
    }
    if (!empty($this->tblPrefix)) {
      $this->flogin->login_db = $this->tblPrefix;
    }
    
    if (isset($_GET["logout"]) && $_GET["logout"]=="yes") {
      $this->flogin->logout();
      Viper2::$router->redirectTo(Viper2::$router->basePage() . preg_replace('/(\?.*)/', '', Viper2::$router->uri()));
    }
    // var_dump($this->flogin);

    if (isset($_POST["user_login"]) && isset($_POST["user_pass"])) {
      $loginRes = $this->flogin->checkLogin($_POST["user_login"], $_POST["user_pass"]);
      Viper2::setVar("OTPUsed", $this->flogin->OTPUsed);
      $_POST["user_pass"] = "--hidden-password--";
    } else {
      $loginRes = $this->flogin->checkLogin();
    }

    if ($this->flogin->logged()) {
      Viper2::setVar("flogin", $this->flogin);
      Viper2::setVar("logged", TRUE);
      Viper2::setVar("loginUid", $this->flogin->login_uid());
      if (Viper2::$useSmarty) {
        Viper2::$smarty->assign("logged", 1);
        Viper2::$smarty->assign("loginUid", $this->flogin->login_uid());
      }
    }

    if (PEAR::isError($loginRes)) {
      v2("Msgbox", "add", __LINE__." : ".$login_res->getMessage());
    } else {
      if(!$loginRes && $this->flogin->login_status!=""){
        v2("Msgbox", "add", $this->flogin->login_status);
      }
    }

    if($this->flogin->logged()){
      $userInfo = new flogin_user($this->dbh);
      $userInfo->login_db = $this->tblPrefix;
      $userInfo->load($this->flogin->login_uid());
      Viper2::setVar("userInfo", $userInfo);
      if (Viper2::$useSmarty) {
        Viper2::$smarty->assign_by_ref("userInfo", $userInfo);
      }
      
      foreach(Viper2::getActivePluginNames() as $plugin){
        // echo $plugin._nl;
        v2($plugin, "loadRights");
      }
      
    }
    
  }

  public function showGlobal() {
    $_SESSION["WasLogged"] = Viper2::getVar("logged");
  }

}
